=== debian/changelog ===
ppsspp (1.19.3-0deepin1) unstable; urgency=medium

  * Downgrade to 1.19.3-0deepin1 for deepin versioning.
  * remove support mips64

 -- lhdjply <lhdjply@126.com>  Mon, 18 Aug 2025 14:57:03 +0800

ppsspp (1.19.3-1deepin1) unstable; urgency=medium

  * support loongarch64 riscv64 mips64
  * sdl set default version
  * remove qt version
  * remove libretro

 -- lhdjply <lhdjply@126.com>  Mon, 11 Aug 2025 11:08:03 +0800

ppsspp (1.19.3-1~25.04~ppa1) plucky; urgency=medium

  * New upstream release
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Mon, 14 Jul 2025 19:33:23 +0800

ppsspp (1.19.2-1~25.04~ppa1) plucky; urgency=medium

  * New upstream release
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Mon, 16 Jun 2025 20:12:38 +0800

ppsspp (1.19.1-1~25.04~ppa1) plucky; urgency=medium

  * New upstream release
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Tue, 10 Jun 2025 21:26:19 +0800

ppsspp (1.19.0-1~25.04~ppa2) plucky; urgency=medium

  * debian/patches/android.patch: add missing android files

 -- Xu Zhen <xuzhen@fastmail.com>  Fri, 06 Jun 2025 22:57:20 +0800

ppsspp (1.19.0-1~25.04~ppa1) plucky; urgency=medium

  * New upstream release
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Fri, 06 Jun 2025 21:23:13 +0800

ppsspp (1.18.1-1~25.04~ppa1) plucky; urgency=medium

  * Build for 25.04

 -- Xu Zhen <xuzhen@fastmail.com>  Sat, 21 Dec 2024 22:49:16 +0800

ppsspp (1.18.1-1~24.10~ppa1) oracular; urgency=medium

  * New upstream release
  * debian/patches/miniupnpc.patch: Fix FTBFS
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Tue, 05 Nov 2024 19:28:30 +0800

ppsspp (1.18.0-1~24.10~ppa1) oracular; urgency=medium

  * New upstream release
  * debian/patches/miniupnpc.patch: Fix FTBFS
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Mon, 04 Nov 2024 21:01:20 +0800

ppsspp (1.17.1-1~ppa4~24.10) oracular; urgency=medium

  * debian/patches/miniupnp.patch: Fix FTBFS

 -- Xu Zhen <xuzhen@fastmail.com>  Sun, 03 Nov 2024 11:43:37 +0800

ppsspp (1.17.1-1~ppa3~24.10) oracular; urgency=medium

  * Rebuild against libminiupnpc18

 -- Xu Zhen <xuzhen@fastmail.com>  Sat, 02 Nov 2024 10:04:25 +0800

ppsspp (1.17.1-1~ppa2~24.10) oracular; urgency=medium

  * Build for 24.10

 -- Xu Zhen <xuzhen@fastmail.com>  Mon, 24 Jun 2024 20:17:34 +0800

ppsspp (1.17.1-1~ppa2~24.04) noble; urgency=medium

  * Rebuild against t64 libraries

 -- Xu Zhen <xuzhen@fastmail.com>  Fri, 29 Mar 2024 20:19:43 +0800

ppsspp (1.17.1-1~ppa1~24.04) noble; urgency=medium

  * New upstream release
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Sun, 04 Feb 2024 22:00:14 +0800

ppsspp (1.17.0-1~ppa1~24.04) noble; urgency=medium

  * New upstream release
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Sun, 28 Jan 2024 12:22:26 +0800

ppsspp (1.16.6-1~ppa3~23.10) mantic; urgency=medium

  * Build without libsdl2-ttf

 -- Xu Zhen <xuzhen@fastmail.com>  Sat, 14 Oct 2023 01:31:25 +0800

ppsspp (1.16.6-1~ppa2~23.10) mantic; urgency=medium

  * debian/rules: various changes

 -- Xu Zhen <xuzhen@fastmail.com>  Sat, 14 Oct 2023 01:01:41 +0800

ppsspp (1.16.6-1~ppa1~23.10) mantic; urgency=medium

  * New upstream release
  * debian/patches/use_glvnd.patch: prefer GLVND libraries
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Fri, 13 Oct 2023 20:59:11 +0800

ppsspp (1.16.5-1~ppa1~23.10) mantic; urgency=medium

  * New upstream release
  * debian/patches/use_glvnd.patch: prefer GLVND libraries
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Thu, 28 Sep 2023 20:27:59 +0800

ppsspp (1.16.4-1~ppa1~23.10) mantic; urgency=medium

  * New upstream release
  * debian/patches/use_glvnd.patch: prefer GLVND libraries
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Mon, 25 Sep 2023 22:11:20 +0800

ppsspp (1.16.3-1~ppa1~23.10) mantic; urgency=medium

  * New upstream release
  * debian/patches/use_glvnd.patch: prefer GLVND libraries
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Sat, 23 Sep 2023 15:03:43 +0800

ppsspp (1.16.2-1~ppa1~23.10) mantic; urgency=medium

  * New upstream release
  * debian/patches/use_glvnd.patch: prefer GLVND libraries
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Tue, 19 Sep 2023 20:00:35 +0800

ppsspp (1.16.1-1~ppa1~23.10) mantic; urgency=medium

  * New upstream release
  * debian/patches/use_glvnd.patch: prefer GLVND libraries
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Wed, 13 Sep 2023 22:34:41 +0800

ppsspp (1.16.0-1~ppa2~23.10) mantic; urgency=medium

  * debian/patches/fixtype.patch: Fix FTBFS
  * Build ppsspp_libretro.so

 -- Xu Zhen <xuzhen@fastmail.com>  Sun, 10 Sep 2023 20:55:53 +0800

ppsspp (1.16.0-1~ppa1~23.10) mantic; urgency=medium

  * New upstream release
  * debian/patches/use_glvnd.patch: prefer GLVND libraries
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Sun, 10 Sep 2023 13:52:10 +0800

ppsspp (1.15.4-1~ppa1~23.04) lunar; urgency=medium

  * New upstream release
  * debian/patches/use_glvnd.patch: prefer GLVND libraries

