=== debian/control ===
Source: ppsspp
Section: games
Priority: optional
Maintainer: Xu Zhen <xuzhen@fastmail.com>
Build-Depends: debhelper (>= 12),
               dh-exec,
#              clang [armhf],
               cmake (>= 3.16),
               libgl-dev, 
               libglew-dev,
               libminiupnpc-dev,
               libpng-dev (>= 1.6) [i386 amd64],
               libsdl2-dev,
               libsnappy-dev,
               libvulkan-dev,
               libwayland-dev,
               libzip-dev,
               libzstd-dev,
               python3,
               zlib1g-dev
Standards-Version: 4.0.0
Homepage: http://www.ppsspp.org

Package: ppsspp
Architecture: any
Depends: ppsspp-common (= ${source:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Sony PSP emulator - SDL version
 PPSSPP can run your PSP games on your PC in full HD resolution. It can even 
 upscale textures that would otherwise be too blurry as they were made for 
 the small screen of the original PSP.
 .
 All trademarks are property of their respective owners. The emulator is for 
 educational and development purposes only and it may not be used to play games
 you do not legally own.
 .
 This package provides the SDL port which relies in less dependencies,
 such as Qt libraries.

Package: ppsspp-common
Architecture: all
Depends: ${misc:Depends}
Description: Common files for PPSSPP
 PPSSPP can run your PSP games on your PC in full HD resolution. It can even 
 upscale textures that would otherwise be too blurry as they were made for 
 the small screen of the original PSP.
 .
 All trademarks are property of their respective owners. The emulator is for 
 educational and development purposes only and it may not be used to play games
 you do not legally own.
 .
 This package provides common files for PPSSPP.
